﻿using System.Diagnostics;
using System.Text;
namespace ConsoleApp1
{
    internal class Program
    {
        static void Main(string[] args)
        {
            Trace.Listeners.Add(new TextWriterTraceListener(File.CreateText("Data/Log.txt")));
            Trace.AutoFlush = true;
            Trace.WriteLine("Запуск основного кода");


            Solution.Coding();
        }
    }
    public class WorkWithData
    {
        public static int[,] ReadGraph() //метод считывает данные из файла
        {
            Trace.WriteLine("Считывание ребер.");
            int count = 0; //количество ребер
            using (StreamReader sr = new("Data/Data.csv"))
            {
                while (!sr.EndOfStream)
                {
                    sr.ReadLine();
                    count++;
                }
                sr.Close();
            }
            int[,] graph = new int[count, 2];
            int i = 0;
            using (StreamReader sr = new("Data/Data.csv"))
            {
                while (!sr.EndOfStream)
                {
                    string[] array = sr.ReadLine().Split(";");
                    graph[i, 0] = Convert.ToInt32(array[0]);
                    graph[i, 1] = Convert.ToInt32(array[1]);
                    i++;
                }
                sr.Close();
            }
            return graph;
        }
        public static void ShowData(string code) //показывает все данные, граф и код
        {
            int[,] graph = ReadGraph();
            Console.WriteLine("Граф");
            for (int i = 0; i < graph.GetLength(0); i++)
            {
                Console.WriteLine(graph[i, 0] + " " + graph[i, 1]);
            }
            Console.WriteLine("\nКод Прюфера = " + code);
        }
        public static void WriteRezults(string code)
        {
            Trace.WriteLine("Запись результатов = " + code);
            using (StreamWriter sr = new StreamWriter(File.Open("Data/Code.txt", FileMode.OpenOrCreate), Encoding.UTF8))
            {
                sr.WriteLine(code);
                sr.Close();
            }
        }
    }
    public class Solution
    {
        public static int GetMin(int[,] graph) //поиск минимального листа
        {
            int min = 10;
            bool notExists = true;
            for (int i = 0; i < graph.GetLength(0); i++)
            {
                for (int j = 0; j < graph.GetLength(0); j++) //проверка на лист
                {
                    if (graph[i, 1] == graph[j, 0])
                    {
                        notExists = false;
                        break;
                    }
                }
                if ((notExists) && (graph[i, 1] < min) && (graph[i, 1] != 0))
                {
                    min = graph[i, 1];
                }
                notExists = true;
            }
            Trace.WriteLine("Минимум = " + min);
            return min;
        }
        public static void Coding() //кодирование
        {
            int[,] graph = WorkWithData.ReadGraph();
            string code = "";
            for (int i = 0; i < graph.GetLength(0); i++)
            {
                for (int j = 0; j < graph.GetLength(0); j++)
                {
                    if (graph[j, 1] == GetMin(graph))
                    {
                        Trace.WriteLine("Закодировано ребро " + graph[j, 0] + "-" + graph[j,1]);
                        code += graph[j, 0];
                        graph[j, 0] = 0;
                        graph[j, 1] = 0;
                        break;
                    }
                }
            }
            code = code.Substring(0, code.Length - 1);
            WorkWithData.ShowData(code);
            WorkWithData.WriteRezults(code);
        }
    }
}